! *******************************************************************************
! xHeaderClass -   
! *******************************************************************************
 MEMBER

 MAP
 END

 include('xHeaderClass.inc'),ONCE

! *******************************************************************************
xHeaderClass.Construct PROCEDURE
 code
 self.qColInfo &= new(typeColumnInfo)
 free(self.qColInfo)
 self.UseOffset=TRUE    !   
 self.DefaultOffset=8
! *******************************************************************************
xHeaderClass.Destruct PROCEDURE
 code
 if not self.qColInfo &= NULL 
    loop rec#=1 to records(self.qColInfo)
       get(self.qColInfo,rec#)
       if self.qColInfo.FEQ
          destroy(self.qColInfo.FEQ)
       end
    end
    free(self.qColInfo)
    dispose(self.qColInfo)
 end
! *******************************************************************************
xHeaderClass.Init PROCEDURE(LONG inListBox)
 code
 self.ListBoxFEQ=inListBox
 self.SetCallBack(self.ListBoxFEQ{Prop:Handle},self.ListBoxFEQ)
 REGISTER(EVENT:ColumnResize,address(self.Redraw),address(SELF),,self.ListBoxFEQ)
 REGISTER(EVENT:Redraw,address(self.Redraw),address(SELF),,self.ListBoxFEQ)
! *******************************************************************************
xHeaderClass.Kill PROCEDURE
 code
 UNREGISTER(EVENT:ColumnResize,address(self.Redraw),address(SELF),,self.ListBoxFEQ)
 UNREGISTER(EVENT:Redraw,address(self.Redraw),address(SELF),,self.ListBoxFEQ)
 self.RemoveCallback()
! *******************************************************************************
xHeaderClass.SetImage PROCEDURE(STRING inImageName, LONG inCol,<BYTE inAlign>,<LONG inOffset>)
 code
 if NOT self.qColInfo &= NULL  !     
    self.qColInfo.Col=inCol
    get(self.qColInfo,self.qColInfo.Col)
    if errorcode() !    
       clear(self.qColInfo)
       self.qColInfo.Col=inCol
       self.qColInfo.ImageName=inImageName
       if omitted(4)
          self.qColInfo.Align=ALIGN:Left
       else
          self.qColInfo.Align=inAlign
       end
       if omitted(5)
          self.qColInfo.Offset=self.DefaultOffset
       else
          self.qColInfo.Offset=inOffset
       end
       if self.ListBoxFEQ{Proplist:HeaderLeft,self.qColInfo.Col}
          self.qColInfo.InitOffset=self.ListBoxFEQ{Proplist:HeaderLeftOffset,self.qColInfo.Col}
       elsif self.ListBoxFEQ{Proplist:HeaderRight,self.qColInfo.Col}
          self.qColInfo.InitOffset=self.ListBoxFEQ{Proplist:HeaderRightOffset,self.qColInfo.Col}
       elsif self.ListBoxFEQ{Proplist:HeaderCenter,self.qColInfo.Col}
          self.qColInfo.InitOffset=self.ListBoxFEQ{Proplist:HeaderCenterOffset,self.qColInfo.Col}
       end
       add(self.qColInfo)
    else !    
       self.qColInfo.ImageName=inImageName
       if NOT omitted(4) !      
          self.qColInfo.Align=inAlign
       end
       if NOT omitted(5)
          self.qColInfo.Offset=inOffset
       end
       put(self.qColInfo)
    end
 end
! *******************************************************************************
xHeaderClass.Redraw PROCEDURE
 code
 loop rec#=1 to records(self.qColInfo)
    get(self.qColInfo,rec#)
    YIELD
    if NOT self.qColInfo.FEQ                                 !      
       self.qColInfo.FEQ=CREATE(0,CREATE:BUTTON)             !   
       put(self.qColInfo)                                    !   (FEQ) 
    end
    self.qColInfo.FEQ{Prop:Icon}=clip(self.qColInfo.ImageName)
    self.qColInfo.FEQ{Prop:Flat}=TRUE
    self.qColInfo.FEQ{Prop:Skip}=TRUE
    self.qColInfo.FEQ{Prop:Trn}=TRUE
    case self.qColInfo.Align
       of ALIGN:Left
          self.qColInfo.FEQ{Prop:Left}=TRUE
          self.qColInfo.FEQ{Prop:Text}='<13>'
       of AlIGN:Right
          self.qColInfo.FEQ{Prop:Right}=TRUE
          self.qColInfo.FEQ{Prop:Text}='<13>'
       of ALIGN:Center
          self.qColInfo.FEQ{Prop:Text}=''
    end

    self.SetOffset() !  

    PreviousPixels#=0{Prop:Pixels}
    0{Prop:Pixels}=TRUE !     
    self.qColInfo.FEQ{Prop:Width}=self.RealColWidth(self.qColInfo.Col)
    if self.qColInfo.FEQ{Prop:Width}<0 then self.qColInfo.FEQ{Prop:Width}=0.
    self.qColInfo.FEQ{Prop:Height}=self.HeaderHeight()/(self.Levels()+1) - 1
    self.qColInfo.FEQ{Prop:Xpos}=self.ColXpos(self.qColInfo.Col)+self.ListBoxFEQ{Prop:Xpos}
    if self.IsColInGroup(self.qColInfo.Col)
       self.qColInfo.FEQ{Prop:Ypos}=self.ListBoxFEQ{Prop:Ypos}+1+self.HeaderHeight()/2
    else
       self.qColInfo.FEQ{Prop:Ypos}=self.ListBoxFEQ{Prop:Ypos}+1
    end
    0{Prop:Pixels}=PreviousPixels# !   

    if self.IsColVisible(self.qColInfo.Col) !   
       self.qColInfo.FEQ{Prop:Hide}=FALSE !  
    else
       self.qColInfo.FEQ{Prop:Hide}=TRUE
    end
 end
! *******************************************************************************
xHeaderClass.SetOffset PROCEDURE
 code
 if self.UseOffset !     
    if self.ListBoxFEQ{Proplist:HeaderLeft,self.qColInfo.Col}
       self.ListBoxFEQ{Proplist:HeaderLeftOffset,self.qColInfo.Col}=self.qColInfo.Offset+self.qColInfo.InitOffset
    elsif self.ListBoxFEQ{Proplist:HeaderRight,self.qColInfo.Col}
       self.ListBoxFEQ{Proplist:HeaderRightOffset,self.qColInfo.Col}=self.qColInfo.Offset+self.qColInfo.InitOffset
    elsif self.ListBoxFEQ{Proplist:HeaderCenter,self.qColInfo.Col} !     
       self.ListBoxFEQ{Proplist:HeaderCenterOffset,self.qColInfo.Col}=self.qColInfo.Offset+self.qColInfo.InitOffset
    end
 end
! *******************************************************************************
xHeaderClass.RemoveOffset PROCEDURE
 code
 if self.UseOffset !     
    if self.ListBoxFEQ{Proplist:HeaderLeft,self.qColInfo.Col}
       self.ListBoxFEQ{Proplist:HeaderLeftOffset,self.qColInfo.Col}=self.qColInfo.InitOffset
    elsif self.ListBoxFEQ{Proplist:HeaderRight,self.qColInfo.Col}
       self.ListBoxFEQ{Proplist:HeaderRightOffset,self.qColInfo.Col}=self.qColInfo.InitOffset
    elsif self.ListBoxFEQ{Proplist:HeaderCenter,self.qColInfo.Col} !     
       self.ListBoxFEQ{Proplist:HeaderCenterOffset,self.qColInfo.Col}=self.qColInfo.InitOffset
    end
 end
! *******************************************************************************
xHeaderClass.VScrollWidth   PROCEDURE
 code
 return(xdhi_GetSystemMetrics(xdhi_SM_CXVSCROLL))
! *******************************************************************************
xHeaderClass.HeaderHeight PROCEDURE
 code
 return(self.ListBoxFEQ{PROP:HeaderHeight})
! *******************************************************************************
xHeaderClass.RealColWidth PROCEDURE(LONG inCol)
loc:ColXpos  LONG !  x 
loc:ColXNext LONG !   X
loc:Width    LONG
 code
 loc:Width=0
 loc:ColXpos=self.ColXPos(inCol)
 loc:ColXNext=self.ColXPos(inCol+1)

 if loc:ColXNext>self.ListBoxFEQ{PROP:Width}-self.IsVScrollVisible()*self.VScrollWidth()
    if self.IsVScrollVisible()=TRUE
       loc:ColXNext=self.ListBoxFEQ{PROP:Width}-self.VScrollWidth()
    else
       loc:ColXNext=self.ListBoxFEQ{PROP:Width}
    end
 else
    if NOT self.ListBoxFEQ{PROPLIST:Exists,inCol+1} !     
       if self.IsVScrollVisible()=TRUE
          loc:ColXNext=self.ListBoxFEQ{PROP:Width}-self.VScrollWidth()
       else
          loc:ColXNext=self.ListBoxFEQ{PROP:Width}
       end
    end
 end

 loc:Width=loc:ColXNext-loc:ColXpos-1
 if loc:Width<0 then loc:Width=0.
 return(loc:Width)
! *******************************************************************************
xHeaderClass.ColXPos PROCEDURE(LONG inCol)
loc:ColXpos  LONG 
 code
 loc:ColXpos=0
 offset#=0
 loop col#=self.LeftCol(inCol)+1 to inCol-1
    if self.ListBoxFEQ{Proplist:RightBorder,col#}
       offset#+=1
    end
    LastWidth#=self.IsColLastInGroup(col#)
    if LastWidth#
       loc:ColXpos+=LastWidth#
    else
       loc:ColXpos+=self.ListBoxFEQ{PROPLIST:Width,col#}
    end
 end
 loc:ColXpos+=offset#+1 !  1     
 return(loc:ColXpos)
! *******************************************************************************
xHeaderClass.IsVScrollVisible         PROCEDURE()
loc:ReturnValue BYTE
loc:ScrollInfo  LIKE(typeSCROLLINFO)
 code
 loc:ReturnValue=FALSE
 if self.ListBoxFEQ{PROP:VScroll} and self.ListBoxFEQ{Prop:Imm}
    loc:ReturnValue=TRUE
 else
    clear(loc:ScrollInfo)
    loc:ScrollInfo.cbSize=size(typeSCROLLINFO)
    loc:ScrollInfo.fMask=xdhi_SIF_ALL

    if xdhi_GetScrollInfo(self.ListBoxFEQ{Prop:Handle},xdhi_SB_VERT,address(loc:ScrollInfo))
      if loc:ScrollInfo.nMin=0 and loc:ScrollInfo.nMax=0 and loc:ScrollInfo.nPos=0 and loc:ScrollInfo.nTrackPos=0
      else
         loc:ReturnValue=TRUE
      end
    end
 end
 return(loc:ReturnValue)
! *******************************************************************************
xHeaderClass.IsColVisible  PROCEDURE(LONG inCol)
loc:ReturnValue BYTE
loc:Xpos        LONG
 code
 loc:ReturnValue=FALSE
 loc:Xpos=self.ColXPos(inCol)
 if loc:Xpos<self.ListBoxFEQ{Prop:Width} and self.RealColWidth(inCol)<>0
    loc:ReturnValue=TRUE
 end
 return(loc:ReturnValue)
! *******************************************************************************
xHeaderClass.RemoveImage   PROCEDURE(LONG inCol)
 code
 self.qColInfo.Col=inCol
 get(self.qColInfo,self.qColInfo.Col)
 if NOT errorcode()
    self.RemoveOffset() !    
    if self.qColInfo.FEQ
       destroy(self.qColInfo.FEQ)
    end
    delete(self.qColInfo)
 end
! *******************************************************************************
xHeaderClass.CallBackProc PROCEDURE(UNSIGNED hWnd,UNSIGNED Msg,UNSIGNED wParam,LONG lParam)
WM_PAINT        EQUATE(000Fh)
WM_SIZE         EQUATE(0005)
WM_HSCROLL      EQUATE(0114h)
WM_VSCROLL      EQUATE(0115h)
WM_LBUTTONDOWN  EQUATE(0201h)
WM_LBUTTONUP    EQUATE(0202h)
WM_RBUTTONUP    EQUATE(0205h)
MK_SHIFT        EQUATE(04h)
MK_CONTROL      EQUATE(08h)

 code
 case Msg
    of WM_HSCROLL orof WM_VSCROLL orof WM_SIZE
       post(EVENT:Redraw,self.ListBoxFEQ)
    of WM_LBUTTONDOWN
       if self.ListBoxFEQ{PROPLIST:MouseDownRow} = 0 and self.ListBoxFEQ{PROPLIST:MouseDownZone} = LISTZONE:Header
          if self.ListBoxFEQ{PROPLIST:MouseDownField}<>0
             self.OnMouseLeftDown(self.ListBoxFEQ{PROPLIST:MouseDownField})
          end
       end
    of WM_LBUTTONUP
       ExtendedKey#=0
       if band(wParam,MK_CONTROL)=MK_CONTROL !    Ctrl
          ExtendedKey#=MK:CONTROL
       elsif band(wParam,MK_SHIFT)=MK_SHIFT  !    Shift
          ExtendedKey#=MK:SHIFT
       end
       self.OnMouseLeftUp(self.ListBoxFEQ{PROPLIST:MouseUpField},ExtendedKey#)
    of WM_RBUTTONUP
       if self.ListBoxFEQ{PROPLIST:MouseUpRow} = 0 and self.ListBoxFEQ{PROPLIST:MouseDownZone} = LISTZONE:Header
          if self.ListBoxFEQ{PROPLIST:MouseUpField}<>0
             self.TakeMouseRight(self.ListBoxFEQ{PROPLIST:MouseUpField})
          end
       end
 end
 return(PARENT.CallBackProc(hWnd,Msg,wParam,lParam))
! *******************************************************************************
xHeaderClass.IsColLastInGroup PROCEDURE(LONG inCol) !    ,    ,  0
loc:ReturnValue LONG
loc:Width       LONG
loc:ColNo       LONG
 code
 loc:ReturnValue=0
 loc:ColNo=self.ListBoxFEQ{Proplist:GroupNo+Proplist:Group,inCol} !   
 if loc:ColNo
    if self.ListBoxFEQ{Proplist:GroupNo,inCol}<>self.ListBoxFEQ{Proplist:GroupNo,inCol+1}
       loc:Width=0
       loop col#=(inCol-loc:ColNo+1) to (inCol-1)
          loc:Width+=self.ListBoxFEQ{Proplist:Width,col#}
       end
       loc:ReturnValue=self.ListBoxFEQ{Proplist:Width+Proplist:Group,inCol}-loc:Width
    end
 end
 return(loc:ReturnValue)
! *******************************************************************************
xHeaderClass.LeftCol PROCEDURE(LONG inCol) !         
loc:ReturnValue LONG
loc:Groups      QUEUE
No                 LONG
Cols               LONG
                END
 code
 free(loc:Groups)
 loop col#=1 to inCol-1
    loc:Groups.No=self.ListBoxFEQ{Proplist:GroupNo,col#}
    get(loc:Groups,loc:Groups.No)
    if errorcode()
       loc:Groups.No=self.ListBoxFEQ{Proplist:GroupNo,col#}
       loc:Groups.Cols=1
       add(loc:Groups)
    else
       loc:Groups.Cols+=1
       put(loc:Groups)
    end
 end

 loc:ReturnValue=0
 loop i#=1 to self.ListBoxFEQ{PROP:HScrollPos}
    get(loc:Groups,i#)
    if NOT errorcode()
       loc:ReturnValue+=loc:Groups.Cols
    end
 end
 return(loc:ReturnValue)
! *******************************************************************************
xHeaderClass.Levels PROCEDURE() !     
loc:ReturnValue BYTE
loc:ColNo       LONG
 code
 loc:ReturnValue=FALSE
 col#=0
 loop
   col#+=1
   if NOT self.ListBoxFEQ{Proplist:Exists,col#} then break.
   loc:ColNo=self.ListBoxFEQ{Proplist:GroupNo+Proplist:Group,col#}
   if loc:ColNo
      loc:ReturnValue=TRUE
      break
   end
 end
 return(loc:ReturnValue)
! *******************************************************************************
xHeaderClass.OnMouseLeftDown PROCEDURE(LONG inCol)
 code
 self.PreviousCapture=xdhi_SetCapture(self.ListBoxFEQ{Prop:Handle})
 self.PressedCol=inCol
 PreviousPixels#=0{Prop:Pixels}
 0{Prop:Pixels}=TRUE
 self.RegionFEQ=CREATE(0,CREATE:Region)
 self.RegionFEQ{Prop:Trn}=TRUE
 self.RegionFEQ{Prop:Xpos}=self.ColXpos(inCol)+self.ListBoxFEQ{Prop:Xpos}
 self.RegionFEQ{Prop:Width}=self.RealColWidth(inCol)-1
 if self.IsColInGroup(inCol)
    self.RegionFEQ{Prop:Height}=self.HeaderHeight()/2-1
    self.RegionFEQ{Prop:Ypos}=self.ListBoxFEQ{Prop:Ypos}+1+self.HeaderHeight()/2
 else
    self.RegionFEQ{Prop:Height}=self.HeaderHeight()-1
    self.RegionFEQ{Prop:Ypos}=self.ListBoxFEQ{Prop:Ypos}+1
 end
 self.RegionFEQ{PROP:Bevel,1} = -1
 unhide(self.RegionFEQ)
 0{Prop:Pixels}=PreviousPixels#
! *******************************************************************************
xHeaderClass.OnMouseLeftUp PROCEDURE(LONG inCol,LONG inExKey)
 code
 if self.PreviousCapture
    xdhi_SetCapture(self.PreviousCapture)
    xdhi_ReleaseCapture()
    self.PreviousCapture=0
 end
 if self.RegionFEQ
    destroy(self.RegionFEQ)
    self.RegionFEQ=0
 end
 if self.PressedCol=inCol and self.ListBoxFEQ{PROPLIST:MouseUpRow}=0 and self.ListBoxFEQ{PROPLIST:MouseUpZone}=LISTZONE:Header and self.PressedCol<>0
    self.TakeMouseLeft(self.PressedCol,inExKey)
 end
 self.PressedCol=0
! *******************************************************************************
xHeaderClass.TakeMouseLeft  PROCEDURE(LONG inCol,LONG inExKey)
 code
! *******************************************************************************
xHeaderClass.TakeMouseRight PROCEDURE(LONG inCol)
 code
! *******************************************************************************
xHeaderClass.IsColInGroup         PROCEDURE(LONG inCol)
loc:ReturnValue BYTE
loc:ColNo       LONG
 code
 loc:ReturnValue=FALSE
 loc:ColNo=self.ListBoxFEQ{Proplist:GroupNo+Proplist:Group,inCol}
 if loc:ColNo then loc:ReturnValue=TRUE.
 return(loc:ReturnValue)
